import { Type } from "./type";
export declare const enum UnionOrIntersectionTypeKind {
    Union = 100,
    Intersection = 101,
}
/**
 * Union or intersection type specification
 *
 * @export
 * @class UnionOrIntersectionType
 * @extends {Type}
 */
export declare class UnionOrIntersectionType extends Type {
    private _kind;
    private _types;
    /**
     * Identify the type as Union or Intersection type
     *
     * @type {UnionOrIntersectionTypeKind}
     * @memberOf UnionOrIntersectionType
     */
    kind: UnionOrIntersectionTypeKind;
    /**
     * Array of type specifications for the union or intersection
     *
     * @type {Type[]}
     * @memberOf UnionOrIntersectionType
     */
    types: Type[];
    constructor(text: string, kind: UnionOrIntersectionTypeKind);
}
