"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var type_1 = require("./type");
var UnionOrIntersectionTypeKind;
(function (UnionOrIntersectionTypeKind) {
    UnionOrIntersectionTypeKind[UnionOrIntersectionTypeKind["Union"] = 100] = "Union";
    UnionOrIntersectionTypeKind[UnionOrIntersectionTypeKind["Intersection"] = 101] = "Intersection";
})(UnionOrIntersectionTypeKind = exports.UnionOrIntersectionTypeKind || (exports.UnionOrIntersectionTypeKind = {}));
/**
 * Union or intersection type specification
 *
 * @export
 * @class UnionOrIntersectionType
 * @extends {Type}
 */
var UnionOrIntersectionType = (function (_super) {
    __extends(UnionOrIntersectionType, _super);
    function UnionOrIntersectionType(text, kind) {
        var _this = _super.call(this, text) || this;
        _this._kind = kind;
        _this._types = [];
        return _this;
    }
    Object.defineProperty(UnionOrIntersectionType.prototype, "kind", {
        /**
         * Identify the type as Union or Intersection type
         *
         * @type {UnionOrIntersectionTypeKind}
         * @memberOf UnionOrIntersectionType
         */
        get: function () {
            return this._kind;
        },
        set: function (value) {
            this._kind = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnionOrIntersectionType.prototype, "types", {
        /**
         * Array of type specifications for the union or intersection
         *
         * @type {Type[]}
         * @memberOf UnionOrIntersectionType
         */
        get: function () {
            return this._types;
        },
        set: function (value) {
            this._types = value;
        },
        enumerable: true,
        configurable: true
    });
    return UnionOrIntersectionType;
}(type_1.Type));
exports.UnionOrIntersectionType = UnionOrIntersectionType;
